//Listing 2.33 Client code for Apache SOAP Service in listing 2.32
//XML - A Dsitributed Computing Paradigm - Ajay M R

package myservice;

import java.net.URL;
import java.util.Vector;            
import org.apache.soap.SOAPException;
import org.apache.soap.Constants;
import org.apache.soap.Fault;
import org.apache.soap.rpc.Call;
import org.apache.soap.rpc.Parameter;
import org.apache.soap.rpc.Response;

// SOAP Client written by Sandesh Salunke & Pradyumna Asmar

public class mySOAPClient
{
   public static void main(String[] args) throws Exception 
   {      
      if(args.length == 0)
      {
         System.err.println("Usage: java myhelloservice.mySOAPClient [SOAP-router-URL] ");
         System.exit (1);
      }

      try
      {
         URL url = null;
         String name = null;              
         if(args.length == 2)
         {
            url = new URL(args[0]);
            name = args[1];
         }
         else
         {
            url = new URL("http://Apache_SOAP_RPC_Webserver_here/apache-soap/servlet/rpcrouter");         
            name = args[0];
         }

         // Cosntruct the Call
         Call call = new Call();
         call.setTargetObjectURI("urn:myHelloService");
         call.setMethodName("greetTo");
         call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);         
         Vector params = new Vector();         
         params.addElement(new Parameter("name", String.class, name, null));
         call.setParams(params);

         // Execute the SOAP call using invoke() call.
         Response resp = null;         
         try
         {
            resp = call.invoke(url, "");
         }
         catch( SOAPException e )
         {
            System.err.println("Exception Occured SOAP (" + e.getFaultCode() + "): " + e.getMessage());
            System.exit(-1);
         }
   
         // verify response for any faults
         if( !resp.generatedFault() )
         {
            Parameter ret = resp.getReturnValue();
            Object value = ret.getValue();            
            System.out.println(value);
         }
         else
         {
	       // if fault occurred then print the fault details on the console....
            Fault fault = resp.getFault();            
            System.err.println("Generated fault: ");
            System.out.println ("  Fault ID   = " + fault.getFaultCode());  
            System.out.println ("  Fault Message = " + fault.getFaultString());
         }
      }
      catch(Exception e)
      {
	    // Display the error stack on console....
         e.printStackTrace();
      }
   }   
}
//