//Listing 10.13 The SomeServiceProxy class
//XML - A Distributed Computing Paradigm - Ajay M R

//java imports.
import java.util.*;
import java.io.*;
//RMI imports.
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
//JINI imports.
import net.jini.discovery.DiscoveryListener;
import net.jini.discovery.DiscoveryEvent;
import net.jini.discovery.LookupDiscovery;
import net.jini.core.lookup.ServiceItem;
import net.jini.core.lookup.ServiceRegistrar;
import net.jini.core.lookup.ServiceRegistration;

/**
 * Light weight proxy object for Hello World Service 
 * which will be downloaded by the client using JINI protocol.
 * It implements Serialiable to support run time serialization over the 
 * network to client side. The behaviour of proxy is specified by 
 * HelloWorldInterface interface thus restricting the proxy to provide
 * implementation for getMessage() method which is defind under 
 * HelloWorldServiceInterface interface.
 * 
 * @author : Ravinder Khokhar
 * @version : $Revision 1.0$
 */
class SomeServiceProxy implements Serializable, 
                                        SomeServiceInterface {
    /** 
     * public constructor needed.
     */
    public SomeServiceProxy() {
        
    }//public constructor ends here.
    
    /**
     * returns a 'hello world' message.
     * @return String 'Hello World' String.
     */
    public String getMessage(){
        
        return "Hello World from SomeServiceProxy";
        
    }//getMessage method ends here.
    
}//SomeServiceProxy ends here.

