/* Static Model */
package sams;


import sams.ErrorQueueInterface;
import sams.XMLDocumentInstance;
/* Query engine is the core for executing all the message tasks. It processes the query messages and allocates a token for each for inter-system QoS. */
public interface QueryEngineInterface
{
	/* Initializes the engine. Would basically set the various internal defaults after reading the associated configuration file. */
	public abstract boolean InitializeEngine();
	/* Main method of the interface, which would execute the generic message packet task and return the results in XML format to the calling method. If some error occurs in the process the resultant XML stream would contain the reference error token for picking that error from error queue. */
	public abstract XMLDocumentInstance ExecuteQuery(XMLDocumentInstance QueryPacket);
	/* Allows users to inquire about query status. The query is referred by the Token#. */
	public abstract int InquireAboutQueryStatus(double QueryToken,
											 char MthodName);
	/* This sets the reference object for using the Error Queue in the system. */
	public abstract boolean SetErrorQueueReference(ErrorQueueInterface ErrorQueueReference);

}
/* END CLASS DEFINITION QueryEngineInterface */
