/* Static Model */
package sams;


import sams.XMLDocumentInstance;
/* RPC Communication interface allows XML-RPC to be used to interact with the query engine. */
public interface RPCCommunicationInterface
{
	/* Initialize RPC services, reads the security and configuration parameters and also acts as wrapper on current RPC services over web services. */
	public abstract boolean InitializeRPCServices();
	/* Set central processor reference. */
	public abstract void SetCentralProcessorReferences();
	/* Process RPC Request passed as parameter, returns the results in XML format. */
	public abstract XMLDocumentInstance ProcessRPCRequest(XMLDocumentInstance RPCRequest);
	/* Validate RPC Request XML stream. */
	public abstract boolean ValidateRPCRequest(XMLDocumentInstance RPCRequestXML);

}
/* END CLASS DEFINITION RPCCommunicationInterface */
